#include <iostream>

using namespace std;

int main()
{
    int N, Q;
    cin>>N>>Q;

    long long dani[N];
    int pakovanja[N];

    for (int i = 0; i < N; i++)
    {
        cin >> dani[i] >> pakovanja[i];
    }

    long long prekid[Q];

    for (int i=0; i<Q; i++)
    {
        cin >> prekid[i];
    }

    for (int q=0; q<Q; q++)
    {
        long long dan_kada_prekida=prekid[q];
        long long broj_pojedene_plazme=0;
        long long brojpakovanja=0;
        int k=0;

        for (int i = 1; i <= dan_kada_prekida; i++)
        {

            if(i==dani[k])
            {
                brojpakovanja+=pakovanja[k];
                k++;
            }

            if (brojpakovanja>0)
            {
                brojpakovanja--;
                broj_pojedene_plazme++;
            }
        }

        cout<<broj_pojedene_plazme<<endl;
    }

    return 0;
}